from .client import Client
from collections.abc import Callable, Sequence
from radkit_client.async_.settings import get_settings as get_settings
from radkit_common import nglog
from radkit_common.settings import Theme
from typing import Any

__all__ = ['init_nglog', 'change_settings', 'get_settings', 'start_radkit_client', 'run_radkit_client', 'monkey_patch_typing_fix_generic_signature']

def init_nglog(log_level: nglog.LogLevel, tracebacks: bool) -> None: ...
def change_settings(settings: dict[str, Any] | str) -> None: ...
def start_radkit_client(*, log_level: nglog.LogLevel | None = None, tracebacks: bool = False, interactive: bool = False, script: str | None, script_args: Sequence[str] | None, theme: Theme = ..., domain: str | None = None) -> None: ...
def run_radkit_client(*, client: Client, scope: dict[str, object], interactive: bool = True, interactive_help_func: Callable[[], None] | None = None, script: str | None = None, script_args: Sequence[str] | None = None, theme: Theme = ..., domain: str | None = None) -> None: ...
def monkey_patch_typing_fix_generic_signature() -> None: ...
